include "Vram.inc"
include "Chars.inc"

ext MonoPatternSource_, ColorPatternSource_, SpritePatternSource_, LinePatternSource_
ext CharPattern_, SpritePattern_

zseg
charCount:
    defb 0
yCount:
    defb 0
byteCount:
    defb 0
bitCount:
    defb 0
charColor:
    defb 0
planeCount:
    defb 0
invertedByte:
    defb 0
pPattern:
    defw 0


cseg
MonoPattern:
    sta <charCount
    do
        pshs b
            stb <charColor
            lda #3
            sta <planeCount
            do
                pshs y
                    lda #CharHeight
                    sta <yCount
                    do
                        clrb
                        lda <charColor
                        bita #$01
                        if ne
                            orb ,y
                        endif
                        bita #$10
                        if ne
                            lda ,y
                            coma
                            sta <invertedByte
                            orb <invertedByte
                        endif
                        lda #2
                        sta <byteCount
                        do
                            lda #4
                            sta <bitCount
                            clra
                            do
                                lsla
                                lsla
                                lslb
                                if cs
                                    ora #$03
                                endif
                                dec <bitCount
                            while ne | wend
                            sta ,x+
                            dec <byteCount
                        while ne | wend
                        leay 1,y
                        dec <yCount
                    while ne | wend
                    lsr <charColor
                    dec <planeCount
                puls y
            while ne | wend
            leay CharHeight,y
        puls b
        dec <charCount
    while ne | wend
rts


; void InitMonoPattern();
cseg
ColorTable:
    defb 64,7
    defb 16,5
    defb 2,2
    defb 1,7
    defb 2,6
    defb 2,1
    defb 0
InitMonoPattern_: public InitMonoPattern_
    pshs a,b,x,y
        ldy #MonoPatternSource_ | sty <pPattern
        ldx #CharPattern_
        ldy #ColorTable
        do
            lda ,y+
        while ne
            ldb ,y+
            pshs y
                ldy <pPattern
                bsr MonoPattern
                sty <pPattern
            puls y
        wend
    puls a,b,x,y
rts


; void InitColorPattern();
cseg
InitColorPattern_: public InitColorPattern_
    pshs a,b,x,y
        ldx #CharPattern_+PatternSize*Char_MyFort
        ldy #ColorPatternSource_
        lda #Char_End-Char_MyFort | sta <charCount
        do
            lda #CharHeight*3
            sta <yCount
            do
                ldb ,y+
                lda #2
                sta <byteCount
                do
                    lda #4
                    sta <bitCount
                    clra
                    do
                        lsla
                        lsla
                        lslb
                        if cs
                            ora #$03
                        endif
                        dec <bitCount
                    while ne | wend
                    sta ,x+
                    dec <byteCount
                while ne | wend
                dec <yCount
            while ne | wend
            dec <charCount
        while ne | wend
    puls a,b,x,y
rts


; void InitSpritePattern();
cseg
InitSpritePattern_: public InitSpritePattern_
    pshs a,b,x,y
        ldx #SpritePattern_
        ldy #SpritePatternSource_
        lda #PatternCount | sta <charCount
        do
            lda #CharHeight*4
            sta <yCount
            do
                lda #4
                sta <byteCount
                do
                    ldb ,y+

                    lda #4
                    sta <bitCount
                    clra
                    do
                        lsla
                        lsla
                        lslb
                        if cs
                            ora #$03
                        endif
                        dec <bitCount
                    while ne | wend
                    sta ,x

                    lda #4
                    sta <bitCount
                    clra
                    do
                        lsla
                        lsla
                        lslb
                        if cs
                            ora #$03
                        endif
                        dec <bitCount
                    while ne | wend
                    sta 4,x

                    leax 1,x
                    dec <byteCount
                while ne | wend
                leax 4,x
                dec <yCount
            while ne | wend
            dec <charCount
        while ne | wend
    puls a,b,x,y
rts
