#include "Vram.h"
#include "Chars.h"
#include "Sprite.h"
#include "Sound.h"
#include "VVram.h"

extern byte[] MonoPatternSource, LinePatternSource, ColorPatternSource, SpritePatternSource;
constexpr byte SourceCharSize = 8 * 3;

byte[48 * Char_End] CharPattern;
byte[256 * PatternCount] SpritePattern;

void InitVram()
{
    ClearScreen();
    InitMonoPattern();
    InitColorPattern();
    InitSpritePattern();
}


void DrawAll()
{
    EraseSprites();
    VVramToVram();
    DrawSprites();
    SwapVram();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            Put(vram, c);
            ++c;
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}

void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            Put(vram, Char_Space);
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
