constexpr byte VramWidth = 80;
constexpr byte VramHeight = 25;
constexpr byte CharHeight = 8;
constexpr byte PatternSize = CharHeight * 3;
constexpr byte VramRowSize = VramWidth*CharHeight;
constexpr byte VramStep = VramWidth / 40;

constexpr word Vram = 0xb000;

extern byte[] CharPattern;
extern byte[] SpritePattern;

extern void InitMonoPattern();
extern void InitColorPattern();
extern void InitSpritePattern();

extern void ClearScreen();
extern word Put(word vram, byte c);
extern void VVramToVram();
extern void SwapVram();
extern void EraseBackup(byte x, byte y);
extern void DrawSprite(byte x, byte y, byte pattern);

extern void InitVram();
extern void DrawAll();
extern word PrintC(word vram, byte c);
extern void Put2C(word vram, byte c);
